码迷,mamicode.com
首页 > 其他好文 > 详细

Frog Jump

时间:2016-11-04 23:50:00      阅读:225      评论:0      收藏:0      [点我收藏+]

标签:get   ret   discuss   ota   each   last   ons   als   ble   

A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.

Given a list of stones‘ positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.

If the frog‘s last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.

Note:

  • The number of stones is ≥ 2 and is < 1,100.
  • Each stone‘s position will be a non-negative integer < 231.
  • The first stone‘s position is always 0.

 

Example 1:

[0,1,3,5,6,8,12,17]

There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit.

Return true. The frog can jump to the last stone by jumping 
1 unit to the 2nd stone, then 2 units to the 3rd stone, then 
2 units to the 4th stone, then 3 units to the 6th stone, 
4 units to the 7th stone, and 5 units to the 8th stone.

 

Example 2:

[0,1,2,3,4,8,9,11]

Return false. There is no way to jump to the last stone as 
the gap between the 5th and 6th stone is too large.

分析:
暴力解法:
首先要明白,不是所有的石头都必须要跳上去,题目没有说清楚,上面的例子也很misleading.

暴力解法很简单,从当前点(石头)和跳到当前点的步数,看后面是否有石头可以reach,如果可以,以那个新的石头和新的步数继续递归,如果我们reach到最后一个石头,return true.

 1 public class Solution {
 2     
 3     public boolean canCross(int[] stones) {
 4         
 5         if (stones == null || stones.length == 1) return true;
 6         if (stones[1] - stones[0] != 1) return false; 
 7         
 8         return isPossible(stones, 1, 1);
 9     }
10     
11     public boolean isPossible(int[] stones, int start, int jumps) {
12         if (start == stones.length - 1)
13             return true;
14         for (int i = start + 1; i < stones.length; i++) {
15             int diff = stones[i] - stones[start];
16             if (diff <= jumps + 1 && diff >= jumps - 1) {
17                 if (isPossible(stones, i, diff)) {
18                     return true;
19                 }
20             } 
21         }
22         return false;
23     }
24 }

第二种方法:

来自leetcode 讨论区一个网友的做法,直接贴在下面

https://discuss.leetcode.com/topic/59903/very-easy-to-understand-java-solution-with-explanations

Use map to represent a mapping from the stone (not index) to the steps that can be taken from this stone.

so this will be

[0,1,3,5,6,8,12,17]

{17=[], 0=[1], 1=[1, 2], 3=[1, 2, 3], 5=[1, 2, 3], 6=[1, 2, 3, 4], 8=[1, 2, 3, 4], 12=[3, 4, 5]}

Notice that no need to calculate the last stone.

On each step, we look if any other stone can be reached from it, if so, we update that stone‘s steps by adding step, step + 1, step - 1. If we can reach the final stone, we return true. No need to calculate to the last stone.

 1 public class Solution {
 2 
 3     public boolean canCross(int[] stones) {
 4         if(stones == null || stones.length == 0 || stones[1] != 1 ||
 5                 stones[stones.length - 1] > (stones.length * (stones.length - 1)) / 2) return false;
 6         
 7         HashMap<Integer, HashSet<Integer>> map = new HashMap<Integer, HashSet<Integer>>(stones.length);
 8         map.put(0, new HashSet<Integer>());
 9         map.get(0).add(1);
10         for (int i = 1; i < stones.length; i++) {
11             map.put(stones[i], new HashSet<Integer>() );
12         }
13         
14         for (int i = 0; i < stones.length - 1; i++) {
15             int stone = stones[i];
16             for (int step : map.get(stone)) {
17                 int reach = step + stone;
18                 if (reach == stones[stones.length - 1]) {
19                     return true;
20                 }
21                 HashSet<Integer> set = map.get(reach);
22                 if (set != null) {
23                     set.add(step);
24                     if (step - 1 > 0) set.add(step - 1);
25                     set.add(step + 1);
26                 }
27             }
28         }
29         return false;
30     } 
31 }

 

Frog Jump

标签:get   ret   discuss   ota   each   last   ons   als   ble   

原文地址:http://www.cnblogs.com/beiyeqingteng/p/6031867.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!